#© Copyright 2021 Micro Focus or one of its affiliates.
#The only warranties for products and services of Micro Focus and its affiliates and licensors (“Micro Focus”) are as may be set forth in the express
#warranty statements accompanying such products and services. Nothing herein should be construed as constituting an additional warranty. Micro Focus
#shall not be liable for technical or editorial errors or omissions contained herein. The information contained herein is subject to change without notice.


#!/bin/sh
Cluster_Resource()
{
val=$(systemctl status novell-ncs.service |grep "active (running)" | wc -l)
if [ "$val" -gt "0" ]; then
	cluster resources &> ClusterResource.txt
	perl -anle 'print $F[0]' ClusterResource.txt >List.txt
	count=($(cat List.txt |  wc -l))
	count=$((count - 2))
	echo $(cat List.txt | tail -n $count | perl -p0e 's/(.*\n){0}$//')
	rm -f ClusterResource.txt
	rm -f List.txt 
fi
}
ClusterResource=($(Cluster_Resource))
ncp_Help_list()
{
	ncpcon help &> helplist.txt
	perl -anle 'print $F[0]' helplist.txt >List.txt
	count=($(cat List.txt |  wc -l))
	count=$((count - 1))
	echo $(cat List.txt | tail -n $count | perl -p0e 's/(.*\n){1}$//')
	rm -f helplist.txt
	rm -f List.txt 
}
ncp_Set_list()
{
	ncpcon set &> setlist.txt
	perl -anle 'print $F[0]' setlist.txt >List.txt
	count=($(cat List.txt |  wc -l))
	count=$((count - 2))
	echo $(cat List.txt | tail -n $count | perl -p0e 's/(.*\n){2}$//')
	rm -f setlist.txt
	rm -f List.txt 
}
ncp_connection_list()
{
	ncpcon connection list &> connectionlist.txt
	perl -anle 'print $F[0]' connectionlist.txt >List.txt
	count=($(cat List.txt |  wc -l))
	count=$((count - 6))
	echo $(cat List.txt | tail -n $count | perl -p0e 's/(.*\n){2}$//')
	rm -f connectionlist.txt
	rm -f List.txt 
}
ncp_volume_list()
{
	ncpcon volumes &> volumes.txt
	count=($(cat volumes.txt |  wc -l))
	count=$((count-4))
	echo $(cat volumes.txt | tail -n $count | perl -p0e 's/(.*\n){4}$//')
	rm -f volumes.txt
}
nss_volume_list()
{
	val2=$(systemctl status novell-nss.service |grep "active (running)"|wc -l)
        if [ "$val2" -gt "0" ]; then
		count1=($(nss /volumes | cut -f 1 -d ' ' | wc -l))
		count1=$((count1-2))
		echo $(nss /volumes | cut -f 1 -d ' ' | tail -n $count1)
	fi
}
ncp_volume=($(ncp_volume_list))
nss_volume=($(nss_volume_list))
ncp_connectionlist=($(ncp_connection_list))
ncp_Setlist=($(ncp_Set_list))
ncp_Helplist=($(ncp_Help_list))
function _ncpcon_()
{
	local cur prev prev2 prev3 prev4 prev5 prev6 prev7 prev8 prev9 prev10 prev11

	if [ $COMP_CWORD -eq 1 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
	elif [ $COMP_CWORD -eq 2 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
	elif [ $COMP_CWORD -eq 3 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
	elif [ $COMP_CWORD -eq 4 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
	elif [ $COMP_CWORD -eq 5 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
	elif [ $COMP_CWORD -eq 6 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
		prev5=${COMP_WORDS[COMP_CWORD-5]}
	elif [ $COMP_CWORD -eq 7 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev2=${COMP_WORDS[COMP_CWORD-2]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev4=${COMP_WORDS[COMP_CWORD-4]}
		prev5=${COMP_WORDS[COMP_CWORD-5]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
	elif [ $COMP_CWORD -eq 8 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev=${COMP_WORDS[COMP_CWORD-1]}
		prev7=${COMP_WORDS[COMP_CWORD-7]}
	elif [ $COMP_CWORD -eq 9 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
		prev7=${COMP_WORDS[COMP_CWORD-7]}
		prev8=${COMP_WORDS[COMP_CWORD-8]}
	elif [ $COMP_CWORD -eq 12 ]
	then
		cur=${COMP_WORDS[COMP_CWORD]}
		prev3=${COMP_WORDS[COMP_CWORD-3]}
		prev6=${COMP_WORDS[COMP_CWORD-6]}
		prev9=${COMP_WORDS[COMP_CWORD-9]}
		prev10=${COMP_WORDS[COMP_CWORD-10]}
		prev11=${COMP_WORDS[COMP_CWORD-11]}
	fi
	
	COMPREPLY=()

	if [ $COMP_CWORD -eq 1 ]
	then
		COMPREPLY=( $(compgen -W "${ncp_Helplist[*]}" -- ${cur}) )
	elif [ $COMP_CWORD -eq 2 ]
	then
		case "$prev" in
			"bind" | "unbind")
				COMPREPLY=( $(compgen -W "${ClusterResource[*]} " -- ${cur}) )
				;;
			"change" | "purge")
				COMPREPLY=( $(compgen -W "volume" -- ${cur}) )
				;;
			"connection")
				COMPREPLY=( $(compgen -W "list clear clearALL ${ncp_connectionlist[*]}" -- ${cur}) )
				;;
			 "create" | "remove")
				COMPREPLY=( $(compgen -W "shadow_volume volume" -- ${cur}) )
				;;
			"disable" | "enable")
				COMPREPLY=( $(compgen -W "write login" -- ${cur}) )
				;;
			"dismount")
				COMPREPLY=( $(compgen -W "${ncp_volume[*]} all" -- ${cur}) )
				;;
			"files")
				COMPREPLY=( $(compgen -W "list close" -- ${cur}) )
				;;
			"irm")
				COMPREPLY=( $(compgen -W "view set" -- ${cur}) )
				;;
			"mount")
				COMPREPLY=( $(compgen -W "all ${ncp_volume[*]} ncp_volume=vol_id path=/vol_mntpt" -- ${cur}) )
				;;
			"rights")
				COMPREPLY=( $(compgen -W "view add remove" -- ${cur}) )
				;;
			"quotas")
				COMPREPLY=( $(compgen -W "view sync" -- ${cur}) )
				;;
			"send")
				COMPREPLY=( $(compgen -W "\"text_message\"" -- ${cur}) )
				;;
			"set")
				COMPREPLY=( $(compgen -W "${ncp_Setlist[*]}" -- ${cur}) )
				;;
			"shadow")
				COMPREPLY=( $(compgen -W "${ncp_volume[*]}" -- ${cur}) )
				;;
			"shift")
				COMPREPLY=( $(compgen -W "\"ncp_volume:\path\filename\"" -- ${cur}) )
				;;
			"volume")
				COMPREPLY=( $(compgen -W "${ncp_volume[*]} /v /s" -- ${cur}) )
				;;
			"security")
				COMPREPLY=( $(compgen -W "view encrypt cipher-strength Enforce-MFA enforce" -- ${cur}) )
				;;
			"nss")
				COMPREPLY=( $(compgen -W "resync=<ncp_volume> verify=<ncp_volume>" -- ${cur}) )
				;;
			"log")
				COMPREPLY=( $(compgen -W "ncpserv.log ncp2nss.log ncpcon.log" -- ${cur}) )
				;;
			"help")
				COMPREPLY=( $(compgen -W "${ncp_Helplist[*]}" -- ${cur}) )
				;;
	esac
	elif [ $COMP_CWORD -eq 3 ]
	then
	case "$prev2" in
			"bind" | "unbind")
				COMPREPLY=( $(compgen -W "ipaddress" -- ${cur}) )
				;;
			"change")
				COMPREPLY=( $(compgen -W "${ncp_volume[*]}" -- ${cur}) )
				;;
			"purge")
				COMPREPLY=( $(compgen -W "${nss_volume[*]}" -- ${cur}) )
				;;
			"create")
				COMPREPLY=( $(compgen -W "<volume_name>" -- ${cur}) )
				;;
			"remove")
				case "$prev" in
					"shadow_volume")
						COMPREPLY=( $(compgen -W "${ncp_volume[*]} /l" -- ${cur}) )
						;;
					"volume")
						COMPREPLY=( $(compgen -W "${ncp_volume[*]}" -- ${cur}) )
						;;
				esac
				;;
			"connection")
				case "$prev" in
					"list")
						COMPREPLY=( $(compgen -W "/e /m /n /h" -- ${cur}) )
						;;
					"clear")
						COMPREPLY=( $(compgen -W "<connection_no>" -- ${cur}) )
						;;
					"clearALL")
						COMPREPLY=( $(compgen -W "except" -- ${cur}) )
						;;
				esac
				;;
			"disable" | "enable")
				case "$prev" in
					"write")
						COMPREPLY=( $(compgen -W "${ncp_volume[*]}" -- ${cur}) )
						;;
				esac
				;;
			"files")
				COMPREPLY=( $(compgen -W "<v=ncp_volume> <f=filename> <c=connection_number>" -- ${cur}) )
				;;
			"help")
				case "$prev" in
					"change" | "purge")
						COMPREPLY=( $(compgen -W "volume" -- ${cur}) )
						;;
					"create" | "remove")
						COMPREPLY=( $(compgen -W "shadow_volume volume" -- ${cur}) )
						;;
				esac
				;;
			"irm" | "rights")
				COMPREPLY=( $(compgen -W "path" -- ${cur}) )
				;;
			"quotas")
				case "$prev" in
					"view")
						COMPREPLY=( $(compgen -W "${nss_volume[*]}" -- ${cur}) )
						;;
					"sync")	
						COMPREPLY=( $(compgen -W "ALL MISSING PERCENT" -- ${cur}) )
						;;
				esac
				;;
			"send")
				COMPREPLY=( $(compgen -W "to" -- ${cur}) )
				;;
			"shadow")
				COMPREPLY=( $(compgen -W "operation=lp/ls/mp/ms" -- ${cur}) )
				;;
			"shift")
				COMPREPLY=( $(compgen -W "shadow primary" -- ${cur}) )
				;;
			"volume")
				case "$prev" in
					"/v")
						COMPREPLY=( $(compgen -W "/s" -- ${cur}) )
						;;
					"/s")
						COMPREPLY=( $(compgen -W "/v" -- ${cur}) )
						;;
				esac
				;;
			"security")
				case "$prev" in
					"encrypt")
						COMPREPLY=( $(compgen -W "enable disable enforce" -- ${cur}) )
						;;
					"cipher-strength")
						COMPREPLY=( $(compgen -W "low medium high" -- ${cur}) )
						;;
					"Enforce-MFA")
						COMPREPLY=( $(compgen -W "Yes No" -- ${cur}) )
						;;
					"enforce")
						COMPREPLY=( $(compgen -W "/e /m /em /me" -- ${cur}) )
						;;
				esac
				;;
			"log")
				COMPREPLY=( $(compgen -W "nothing error warning info debug dump all" -- ${cur}) )
				;;
	esac	
	elif [ $COMP_CWORD -eq 4 ]
	then
	case "$prev3" in
			"change")
				COMPREPLY=( $(compgen -W "Inherit_POSIX_Permissions" -- ${cur}) )
				;;
			"connection")
				case "$prev" in
					"except")
						COMPREPLY=( $(compgen -W "<ID's>" -- ${cur}) )
						;;
				esac
				;;
			"create")
				COMPREPLY=( $(compgen -W "<path>" -- ${cur}) )
				;;
			"irm")
				case "$prev2" in
					"set")
						COMPREPLY=( $(compgen -W "all none SRWCEMFA" -- ${cur}) )
						;;
				esac
				;;
			"remove")
				case "$prev" in
					"/l")
						COMPREPLY=( $(compgen -W "${ncp_volume[*]}" -- ${cur}) )
						;;
				esac
				;;
			"rights")
				case "$prev2" in
					"add" | "remove")
						COMPREPLY=( $(compgen -W "<fdn>" -- ${cur}) )
						;;
				esac
				;;
			"quotas")
				case "$prev2" in
					"view")
						COMPREPLY=( $(compgen -W "d u" -- ${cur}) )
						;;
					"sync")
						COMPREPLY=( $(compgen -W "${nss_volume[*]}" -- ${cur}) )
						;;
				esac
				;;
			"send")
				COMPREPLY=( $(compgen -W "all <station>" -- ${cur}) )
				;;
			"shadow")
				COMPREPLY=( $(compgen -W "pattern= owner= uid= time=m/a/c range= size= output=" -- ${cur}) )
				;;
			"security")
				case "$prev2" in
					"enforce")
						COMPREPLY=( $(compgen -W " /a /r " -- ${cur}) )
						;;
				esac
				;;
	esac
	elif [ $COMP_CWORD -eq 5 ]
	then
	case "$prev4" in
			"rights")
				case "$prev3" in
					"add")
						COMPREPLY=( $(compgen -W "all none SRWCEMFA" -- ${cur}) )
						;;
				esac
				;;
			"quotas")
				case "$prev3" in
					"view")
						COMPREPLY=( $(compgen -W "c" -- ${cur}) )
						;;
				esac
				case "$prev2" in
					"ALL" | "MISSING")
						COMPREPLY=( $(compgen -W "d u" -- ${cur}) )
						;;
					"PERCENT")
						COMPREPLY=( $(compgen -W "<percent>" -- ${cur}) )
						;;
				esac
				;;
	esac
	elif [ $COMP_CWORD -eq 6 ]
	then
	case "$prev5" in
			"quotas")
				case "$prev3" in
					"PERCENT")
						COMPREPLY=( $(compgen -W "d u" -- ${cur}) )
						;;
				esac
				;;
	esac				
	fi	

}

complete -F _ncpcon_ ncpcon

